static const char *gwen_xml__vsdtypes=
 "<?xml version='1.0' encoding='UTF-8'?>\n"
 "<xs:schema\n"
 "xmlns:xs=\"http://www.w3.org/2001/XMLSchema\"\n"
 "targetNamespace=\"http://www.w3.org/2001/XMLSchema\"\n"
 "blockDefault=\"#all\"\n"
 "elementFormDefault=\"qualified\">\n"
 "\n"
 "<xs:simpleType name=\"normalizedString\" id=\"normalizedString\">\n"
 "<xs:restriction base=\"xs:string\">\n"
 "<xs:whiteSpace value=\"replace\"\n"
 "id=\"normalizedString.whiteSpace\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"token\" id=\"token\">\n"
 "<xs:restriction base=\"xs:normalizedString\">\n"
 "<xs:whiteSpace value=\"collapse\" id=\"token.whiteSpace\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"language\" id=\"language\">\n"
 "<xs:restriction base=\"xs:token\">\n"
 "<xs:pattern\n"
 "value=\"[a-zA-Z]{1,8}(-[a-zA-Z0-9]{1,8})*\"\n"
 "id=\"language.pattern\">\n"
 "</xs:pattern>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"IDREFS\" id=\"IDREFS\">\n"
 "<xs:restriction>\n"
 "<xs:simpleType>\n"
 "<xs:list itemType=\"xs:IDREF\"/>\n"
 "</xs:simpleType>\n"
 "<xs:minLength value=\"1\" id=\"IDREFS.minLength\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"ENTITIES\" id=\"ENTITIES\">\n"
 "<xs:restriction>\n"
 "<xs:simpleType>\n"
 "<xs:list itemType=\"xs:ENTITY\"/>\n"
 "</xs:simpleType>\n"
 "<xs:minLength value=\"1\" id=\"ENTITIES.minLength\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"NMTOKEN\" id=\"NMTOKEN\">\n"
 "<xs:restriction base=\"xs:token\">\n"
 "<xs:pattern value=\"c+\" id=\"NMTOKEN.pattern\">\n"
 "</xs:pattern>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"NMTOKENS\" id=\"NMTOKENS\">\n"
 "<xs:restriction>\n"
 "<xs:simpleType>\n"
 "<xs:list itemType=\"xs:NMTOKEN\"/>\n"
 "</xs:simpleType>\n"
 "<xs:minLength value=\"1\" id=\"NMTOKENS.minLength\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"Name\" id=\"Name\">\n"
 "<xs:restriction base=\"xs:token\">\n"
 "<xs:pattern value=\"ic*\" id=\"Name.pattern\">\n"
 "</xs:pattern>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"NCName\" id=\"NCName\">\n"
 "<xs:restriction base=\"xs:Name\">\n"
 "<xs:pattern value=\"[i-[:]][c-[:]]*\" id=\"NCName.pattern\">\n"
 "</xs:pattern>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"ID\" id=\"ID\">\n"
 "<xs:restriction base=\"xs:NCName\"/>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"IDREF\" id=\"IDREF\">\n"
 "<xs:restriction base=\"xs:NCName\"/>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"ENTITY\" id=\"ENTITY\">\n"
 "<xs:restriction base=\"xs:NCName\"/>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"integer\" id=\"integer\">\n"
 "<xs:restriction base=\"xs:decimal\">\n"
 "<xs:fractionDigits value=\"0\" fixed=\"true\" id=\"integer.fractionDigits\"/>\n"
 "<xs:pattern value=\"[-+]?[0-9]+\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"nonPositiveInteger\" id=\"nonPositiveInteger\">\n"
 "<xs:restriction base=\"xs:integer\">\n"
 "<xs:maxInclusive value=\"0\" id=\"nonPositiveInteger.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"negativeInteger\" id=\"negativeInteger\">\n"
 "<xs:restriction base=\"xs:nonPositiveInteger\">\n"
 "<xs:maxInclusive value=\"-1\" id=\"negativeInteger.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"long\" id=\"long\">\n"
 "<xs:restriction base=\"xs:integer\">\n"
 "<xs:minInclusive value=\"-9223372036854775808\" id=\"long.minInclusive\"/>\n"
 "<xs:maxInclusive value=\"9223372036854775807\" id=\"long.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"int\" id=\"int\">\n"
 "<xs:restriction base=\"xs:long\">\n"
 "<xs:minInclusive value=\"-2147483648\" id=\"int.minInclusive\"/>\n"
 "<xs:maxInclusive value=\"2147483647\" id=\"int.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"short\" id=\"short\">\n"
 "<xs:restriction base=\"xs:int\">\n"
 "<xs:minInclusive value=\"-32768\" id=\"short.minInclusive\"/>\n"
 "<xs:maxInclusive value=\"32767\" id=\"short.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"byte\" id=\"byte\">\n"
 "<xs:restriction base=\"xs:short\">\n"
 "<xs:minInclusive value=\"-128\" id=\"byte.minInclusive\"/>\n"
 "<xs:maxInclusive value=\"127\" id=\"byte.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"nonNegativeInteger\" id=\"nonNegativeInteger\">\n"
 "<xs:restriction base=\"xs:integer\">\n"
 "<xs:minInclusive value=\"0\" id=\"nonNegativeInteger.minInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"unsignedLong\" id=\"unsignedLong\">\n"
 "<xs:restriction base=\"xs:nonNegativeInteger\">\n"
 "<xs:maxInclusive value=\"18446744073709551615\"\n"
 "id=\"unsignedLong.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"unsignedInt\" id=\"unsignedInt\">\n"
 "<xs:restriction base=\"xs:unsignedLong\">\n"
 "<xs:maxInclusive value=\"4294967295\"\n"
 "id=\"unsignedInt.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"unsignedShort\" id=\"unsignedShort\">\n"
 "<xs:restriction base=\"xs:unsignedInt\">\n"
 "<xs:maxInclusive value=\"65535\"\n"
 "id=\"unsignedShort.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"unsignedByte\" id=\"unsignedByte\">\n"
 "<xs:restriction base=\"xs:unsignedShort\">\n"
 "<xs:maxInclusive value=\"255\" id=\"unsignedByte.maxInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "\n"
 "<xs:simpleType name=\"positiveInteger\" id=\"positiveInteger\">\n"
 "<xs:restriction base=\"xs:nonNegativeInteger\">\n"
 "<xs:minInclusive value=\"1\" id=\"positiveInteger.minInclusive\"/>\n"
 "</xs:restriction>\n"
 "</xs:simpleType>\n"
 "</xs:schema>\n"
;
